#include <errno.h>
#include <stdio.h>
#include <sys/ioctl.h>

#include "HPDI32DocSrcLib.h"

int hpdi32_debug_read(int fd, int verbose)
{
	hpdi32_debug_data_t	debug;
	int					i;
	int					status;

	status	= ioctl(fd, HPDI32_IOCTL_DEBUG_DATA_GET, &debug);

	if (!verbose)
	{
	}
	else if (status == -1)
	{
		printf("ioctl() failure, errno = %d\n", errno);
	}
	else
	{
		printf("Debug Data: device\n");

		for (i = 0; i < HPDI32_DEBUG_DATA_VALUES; i++)
		{
			printf(	" %-2d. 0x%08lX\n",
					i,
					(unsigned long) debug.device[i]);
		}

		printf("Debug Data: driver\n");

		for (i = 0; i < HPDI32_DEBUG_DATA_VALUES; i++)
		{
			printf(	" %-2d. 0x%08lX\n",
					i,
					(unsigned long) debug.driver[i]);
		}
	}

	return(status);
}
