/* This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL). */
/* $Revision: 7 $ */
/* $Date: 8/23/06 10:29a $ */
/*
*	Provide special handling for things specific to the 2.2 kernel.
*/
/* $Log: /NEW SOURCESAFE DATABASE/DIGITAL/Drivers/LINUX/HPDI32/HPDI32_Linux_Ver.1.16.0-GSC-DN/driver/kernel_2_2.h $
 *
 * 7     8/23/06 10:29a Dnewbold
 * Additional porting for newer kernels.
 *
 * 6     8/21/06 10:26a Dnewbold
 * Porting to the 2.6 and 64-bit kernels.
 *
 * 5     2/22/06 10:22a Dnewbold
 * Removed an unused argument to the nopage routine.
 *
 * 4     2/01/06 2:56p Dnewbold
 * Renamed KMALLOC_LIMIT to MEM_MALLOC_LIMIT.
 *
 * 3     9/01/05 1:28p Dnewbold
 * More 2.6 kernel porting.
 *
 * 2     1/25/05 3:46p Dnewbold
 * More modularization work, plus some housekeeping updates.
 *
 * 1     1/14/05 8:04a Dnewbold
*/

#ifndef __KERNEL_2_2_H__
#define __KERNEL_2_2_H__

#if	(LINUX_VERSION_CODE >= KERNEL_VERSION((2),2,0)) && \
	(LINUX_VERSION_CODE <  KERNEL_VERSION(2,3,0))

#include <linux/malloc.h>
#include <linux/wrapper.h>



/* #defines	**************************************************************/

#define	__GFP_NOWARN			0
#define	EVENT_RESUME_IRQ(q,c)		wake_up_interruptible(q)
#define	EVENT_WAIT_IRQ_TO(q,c,t)	interruptible_sleep_on_timeout(q,t)
#define	GET_PAGE(page)			atomic_inc(&(page)->count)
#define	KILL_FASYNC(q,s,b)		kill_fasync((q),(s),(b))
#define	MEM_ALLOC_LIMIT			(2L * 1024L * 1024)
#define	PAGE_RESERVE(vpa)		mem_map_reserve(MAP_NR((vpa)))
#define	PAGE_UNRESERVE(vpa)		mem_map_unreserve(MAP_NR((vpa)))
#define	PCI_DEVICE_LOOP(p)		for (p=pci_devices;p;p=p->next)
#define	PCI_ENABLE_DEVICE(pci)		0
#define	REGION_IO_CHECK(a,s)		check_region(a,s)
#define	REGION_IO_RELEASE(a,s)		release_region(a,s)
#define	REGION_IO_REQUEST(a,s,n)	(void*) (request_region(a,s,n), 1)
#define	REGION_MEM_CHECK(a,s)		0
#define	REGION_MEM_RELEASE(a,s)
#define	REGION_MEM_REQUEST(a,s,n)	(void*) 1
#define	SET_CURRENT_STATE(s)		current->state = (s); mb()
#define	SET_MODULE_OWNER(p)
#define	VADDR_T				unsigned long
#define	VIRT_TO_PAGE(p)			(mem_map + MAP_NR((p)))
#define	VM_FAULT_MINOR			0
#define	VM_OFFSET_BYTES(vma)		((vma)->vm_offset)
#define	VM_RESERVED			0
#define	VM_OPS_UNMAP(vmo,fun)		(vmo).unmap = (fun)
#define	WAIT_QUEUE_ENTRY_INIT(w,c)	(w)->task = (c)
#define	WAIT_QUEUE_ENTRY_T		struct wait_queue
#define	WAIT_QUEUE_HEAD_INIT(q)		init_waitqueue((q))
#define	WAIT_QUEUE_HEAD_T		struct wait_queue*

#define	REMAP_PAGE_RANGE(vma,vm_adrs,ph_adrs,size,prot)	\
	remap_page_range(    vm_adrs,ph_adrs,size,prot)



/* prototypes	**************************************************************/

void		irq_isr(int irq, void* dev_id, struct pt_regs* regs);

unsigned long	mmap_nopage(	struct vm_area_struct*	vma,
				unsigned long		address,
				int			unused);

void		mmap_unmap(	struct vm_area_struct*	vma,
				unsigned long		addr,
				size_t			len);

int		proc_get_info(	char*			page,
				char**			start,
				off_t			offset,
				int			count,
				int			dummy);



#endif
#endif

