/* This software is covered by the GNU GENERAL PUBLIC LICENSE (GPL). */
/* $Revision: 7 $ */
/* $Date: 8/23/06 10:29a $ */
/*
*	Provide special handling for things specific to the 2.4 kernel.
*/
/* $Log: /NEW SOURCESAFE DATABASE/DIGITAL/Drivers/LINUX/HPDI32/HPDI32_Linux_Ver.1.16.0-GSC-DN/driver/kernel_2_4.h $
 *
 * 7     8/23/06 10:29a Dnewbold
 * Additional porting for newer kernels.
 *
 * 6     8/21/06 10:26a Dnewbold
 * Porting to the 2.6 and 64-bit kernels.
 *
 * 5     2/22/06 10:22a Dnewbold
 * Removed an unused argument to the nopage routine.
 *
 * 4     2/01/06 2:57p Dnewbold
 * Renamed KMALLOC_LIMIT to MEM_MALLOC_LIMIT.
 *
 * 3     9/01/05 1:29p Dnewbold
 * More 2.6 kernel porting.
 *
 * 2     1/25/05 3:46p Dnewbold
 * More modularization work, plus some housekeeping updates.
 *
 * 1     1/14/05 8:04a Dnewbold
*/

#ifndef __KERNEL_2_4_H__
#define __KERNEL_2_4_H__

#if	(LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)) && \
	(LINUX_VERSION_CODE <  KERNEL_VERSION(2,5,0))

#include <linux/slab.h>
#include <linux/wrapper.h>



/* #defines	**************************************************************/

#define	__GFP_NOWARN			0
#define	EVENT_RESUME_IRQ(q,c)		wake_up_interruptible(q)
#define	EVENT_WAIT_IRQ_TO(q,c,t)	interruptible_sleep_on_timeout(q,t)
#define	GET_PAGE(page)			get_page((page))
#define	KILL_FASYNC(q,s,b)		kill_fasync(&(q),(s),(b))
#define	MEM_ALLOC_LIMIT			(2L * 1024L * 1024)
#undef	MOD_DEC_USE_COUNT
#define	MOD_DEC_USE_COUNT
#undef	MOD_INC_USE_COUNT
#define	MOD_INC_USE_COUNT
#define	PAGE_RESERVE(vpa)		mem_map_reserve(virt_to_page((vpa)))
#define	PAGE_UNRESERVE(vpa)		mem_map_unreserve(virt_to_page((vpa)))
#define	PCI_DEVICE_LOOP(p)		pci_for_each_dev(p)
#define	PCI_ENABLE_DEVICE(pci)		pci_enable_device(pci)
#define	REGION_IO_CHECK(a,s)		check_region(a,s)
#define	REGION_IO_RELEASE(a,s)		release_region(a,s)
#define	REGION_IO_REQUEST(a,s,n)	((void*) request_region(a,s,n))
#define	REGION_MEM_CHECK(a,s)		check_mem_region(a,s)
#define	REGION_MEM_RELEASE(a,s)		release_mem_region(a,s)
#define	REGION_MEM_REQUEST(a,s,n)	((void*) request_mem_region(a,s,n))
#define	SET_CURRENT_STATE(s)		current->state = (s)
#define	VADDR_T				unsigned long
#define	VIRT_TO_PAGE(p)			virt_to_page((p))
#define	VM_OFFSET_BYTES(vma)		((vma)->vm_pgoff * PAGE_SIZE)
#define	VM_OPS_UNMAP(vmo,fun)
#define	WAIT_QUEUE_ENTRY_INIT(w,c)	init_waitqueue_entry((w),(c))
#define	WAIT_QUEUE_ENTRY_T		wait_queue_t
#define	WAIT_QUEUE_HEAD_INIT(q)		init_waitqueue_head((q))
#define	WAIT_QUEUE_HEAD_T		wait_queue_head_t

#if	(LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,20)) && \
	(RED_HAT_LINUX_KERNEL)

	#define	REMAP_PAGE_RANGE(vma,vm_adrs,ph_adrs,size,prot)	\
		remap_page_range(vma,vm_adrs,ph_adrs,size,prot)
#else
	#define	REMAP_PAGE_RANGE(vma,vm_adrs,ph_adrs,size,prot)	\
		remap_page_range(    vm_adrs,ph_adrs,size,prot)
#endif



/* prototypes	**************************************************************/

void		irq_isr(int irq, void* dev_id, struct pt_regs* regs);

struct page*	mmap_nopage(	struct vm_area_struct*	vma,
				unsigned long		address,
				int			unused);

int		proc_get_info(	char*			page,
				char**			start,
				off_t			offset,
				int			count);



#endif
#endif
