/* $Revision: 2 $ */
/* $Date: 5/30/06 1:11p $ */
/* $Log: /NEW SOURCESAFE DATABASE/DIGITAL/Drivers/LINUX/HPDI32/HPDI32_Linux_Ver.1.15.0-GSC-DN/irq/irq.c $
 *
 * 2     5/30/06 1:11p Dnewbold
 * Added ability to test specific interrupts.
 *
 * 1     4/17/06 5:06p Dnewbold
*/

#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include "HPDI32DocSrcLib.h"
#include "main.h"
#include "util_label.h"
#include "util_scheduler.h"



/******************************************************************************
*
*	Function:	irq_test
*
*	Purpose:
*
*		Perform interrupt tests.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		irq		The mask of interrupts to test.
*
*		fc		The mask of Flow Control interrupts to test.
*
*		gpio	The mask of GPIO interrupts to test.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int irq_test(int fd, int irq, int fc, int gpio)
{
	int	errs	= 0;

	label("Interrupt Tests");
	printf("\n");
	label_level_inc();

	errs	+= irq_0_test(fd, irq, fc, gpio);
	errs	+= irq_1_test(fd, irq, fc, gpio);
	errs	+= irq_2_test(fd, irq, fc, gpio);
	errs	+= irq_3_test(fd, irq, fc, gpio);
	errs	+= irq_4_test(fd, irq, fc, gpio);
	errs	+= irq_5_test(fd, irq, fc, gpio);
	errs	+= irq_6_test(fd, irq, fc, gpio);
	errs	+= irq_7_test(fd, irq, fc, gpio);
	errs	+= irq_8_test(fd, irq);
	errs	+= irq_9_test(fd, irq);
	errs	+= irq_10_test(fd, irq);
	errs	+= irq_11_test(fd, irq);
	errs	+= irq_12_test(fd, irq);
	errs	+= irq_13_test(fd, irq);
	errs	+= irq_14_test(fd, irq);
	errs	+= irq_15_test(fd, irq);

	label_level_dec();
	return(errs);
}



