/* $Revision: 1 $ */
/* $Date: 4/17/06 5:06p $ */
/* $Log: /NEW SOURCESAFE DATABASE/DIGITAL/Drivers/LINUX/HPDI32/HPDI32_Linux_Ver.1.14.0-GSC-DN/irq/rx.c $
 *
 * 1     4/17/06 5:06p Dnewbold
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>

#include "HPDI32DocSrcLib.h"
#include "main.h"
#include "util_label.h"



/* #defines	******************************************************************/

#define	_RX_ENABLE(fd)	hpdi32_reg_mod(	fd,							\
										HPDI32_GSC_BCR,				\
										HPDI32_GSC_BCR_RX_ENABLE,	\
										HPDI32_GSC_BCR_RX_ENABLE,	\
										0)

#define	_TX_ENABLE(fd)	hpdi32_reg_mod(	fd,							\
										HPDI32_GSC_BCR,				\
										HPDI32_GSC_BCR_TX_ENABLE,	\
										HPDI32_GSC_BCR_TX_ENABLE,	\
										0)

#define	_TX_START(fd)	hpdi32_reg_mod(	fd,							\
										HPDI32_GSC_BCR,				\
										HPDI32_GSC_BCR_TX_START,	\
										HPDI32_GSC_BCR_TX_START,	\
										0)



/******************************************************************************
*
*	Function:	_rx_write
*
*	Purpose:
*
*		Write data to the transmitter and around to the receiver.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		samples	The number of samples to write.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

static int _rx_write(int fd, long samples)
{
	__u32	bsr;
	int		errs	= 0;
	long	l;

	errs	+= _RX_ENABLE(fd);
	errs	+= _TX_ENABLE(fd);
	errs	+= _TX_START(fd);

	for (; (errs == 0) && (samples); samples--)
		errs	+= hpdi32_reg_write(fd, HPDI32_GSC_FDR, 0, 0);

	errs	+= _TX_START(fd);

	for (l = 0; (errs == 0) && (l < 10000); l++)
	{
		errs	+= hpdi32_reg_read(fd, HPDI32_GSC_BSR, &bsr, 0);

		if (bsr & HPDI32_GSC_BSR_TX_NOT_EMPTY)
			usleep(100);
		else
			break;
	}

	return(errs);
}



/******************************************************************************
*
*	Function:	rx_write
*
*	Purpose:
*
*		Write data to the transmitter and around to the receiver.
*
*	Arguments:
*
*		fd		The file descriptor for the board to access.
*
*		samples	The number of samples to write.
*
*	Returned:
*
*		>= 0	The number of errors seen.
*
******************************************************************************/

int rx_write(int fd, long samples)
{
	int		errs	= 0;
	long	l;

	for (; (errs == 0) && (samples);)
	{
		l		= (samples > 512) ? 512 : samples;
		errs	+= _rx_write(fd, l);
		samples	-= l;
	}

	usleep(1000);
	return(errs);
}



