/* $Revision: 1 $ */
/* $Date: 12/19/05 1:58p $ */

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

#include "util_count.h"
#include "util_label.h"



/*****************************************************************************
*
*	Function:	count_boards
*
*	Purpose:
*
*		Count the number of installed boards.
*
*	Arguments:
*
*		None.
*
*	Returned:
*
*		> 0		The number of boards found.
*		== 0	No boards were found.
*		< 0		The number of errors encounterred here.
*
*****************************************************************************/

int count_boards(void)
{
	char		buf[1024];
	int			fd;
	const char*	key	= "boards: ";
	char*		ptr;
	int			qty	= 0;

	for (;;)	/* A convenience loop. */
	{
		label("Board Count");
		fd	= open("/proc/hpdi32", S_IRUSR);

		if (fd == -1)
		{
			qty	= -1;
			sprintf(buf, "open() on /proc/hpdi32, errno %d", errno);
			label_fail_text(1, 1, buf);
			break;
		}

		memset(buf, 0, sizeof(buf));
		read(fd, buf, sizeof(buf));
		buf[sizeof(buf) - 1]	= 0;
		close(fd);
		ptr	= strstr(buf, key);

		if (ptr)
		{
			ptr	+= strlen(key);
			qty	= atoi(ptr);
		}

		if (qty <= 0)
		{
			qty	= -1;
			label_fail_text(1, 1, "No boards found.");
		}
		else
		{
			printf("%d\n", qty);
		}

		break;
	}

	return(qty);
}



