/* $Revision: 2 $ */
/* $Date: 2/01/06 3:07p $ */

#include <errno.h>
#include <stdio.h>

#include "HPDI32DocSrcLib.h"
#include "util_label.h"
#include "util_reg.h"



/*****************************************************************************
*
*	Function:	reg_read
*
*	Purpose:
*
*		Put a wrapper around hpdi32_reg_read().
*
*	Arguments:
*
*		fd		The handle to access the device.
*
*		reg		The register to access.
*
*		value	The value read goes here.
*
*		errs	The current number of errors.
*
*		loud	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
*****************************************************************************/

int reg_read(int fd, __u32 reg, __u32* value, int errs, int loud)
{
	if (errs)
	{
		errs	= 0;
	}
	else
	{
		errs	= hpdi32_reg_read(fd, reg, value, 0);
		errs	= (errs == -1) ? 1 : 0;
		label_fail_func(errs, loud, "hpdi32_reg_read");
	}

	return(errs);
}



